% TP 1 de Data Mining : Probabilites et suites de caracteres
% Auteur : Maxime Chambreuil
% Date : 5 Fevrier 2003

close all 
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Proba d'apparition de chaque 
% caractere dans le texte

C = zeros(1,256);
j = fopen('esc.txt')
%j = fopen('test.txt')
while(not(feof(j)));
	line = fgetl(j);
       	ind = double(line);
       	C(ind) = C(ind) + 1;
      	% disp(line);
end;
fclose(j);


plot(C,'o')
aa = (char(15:127));

[num2str((C(15:127)/sum(C))')  char(32*ones(127-15+1,1)) aa']

pC = C(15:127)/sum(C);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Proba d'apparition de chaque 
% caractere en debut de ligne

CdebutLigne = zeros(1,256);
j = fopen('esc.txt')
%j = fopen('test.txt')
while(not(feof(j)));
	line = fgetl(j);
	
	% On teste si la ligne est pas vide
	if not (isempty(line))
		
		% On prend le premier caractere de la ligne
		ind = double(line(1));
	end;
	CdebutLigne(ind) = CdebutLigne(ind) + 1;
      	% disp(line);
end;
fclose(j);


plot(CdebutLigne,'o')
aa = (char(15:127));

[num2str((CdebutLigne(15:127)/sum(CdebutLigne))')  char(32*ones(127-15+1,1)) aa']

pCdebutLigne = CdebutLigne(15:127)/sum(CdebutLigne);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Proba d'apparition de tous les 
% couples de caracteres

T = zeros(256,256);
j = fopen('esc.txt')
%j = fopen('test.txt')
while(not(feof(j)));
	line = fgetl(j);
       	ind = double(line);
	
	% Premier caractere du couple
	ind1 = ind(1:length(ind)-1);
	
	% Deuxieme caractere du couple
	ind2 = ind(2:length(ind));
	
	% On incremente l'apparition du couple
	% dans le tableau
	for i=1:length(ind1)
		T(ind1(i),ind2(i)) = T(ind1(i),ind2(i)) + 1;
		end;
      	% disp(line);
end;
fclose(j);


plot(T,'o')
aa = (char(15:127));

[num2str((T(15:127,15:127)/sum(sum(T)))')  char(32*ones(127-15+1,127-15+1)) aa']

pT = T(15:127,15:127)/sum(sum(T));
imagesc(pT);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generation d'un texte de 100 caracteres

N = 100;
Caractere = zeros(1,100);

pPremierCaractere = rand(1);
Caractere(1) = max(find(cumsum(pCdebutLigne) < pPremierCaractere))+1;
% Caractere(1) = char(debut);

for i=0:N
	probaCondi = pT(Caractere(i+1),1:end)/sum(pT(Caractere(i+1),1:end));
	Caractere(i+2) = max(find(cumsum(probaCondi) < rand(1)))+1;
	end;
char(Caractere+14)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interpretation

% En considerant des couples, on obtient dj des mots 
% dont on reconnait seulement quelques syllabes. 
% On peut tres bien imaginer rencontrer des mots comprhensibles
% en considerant des triplets de caracteres.
